# -*- encoding: utf-8 -*-
##############################################################################
#
#	 Copyright (C) 2010 Kontaxis Panagiotis
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import wizard
import datetime
import pooler
from tools.translate import _
form='''<?xml version="1.0"?>
<form string="Lab Values Progress">
	<field name="patient_id"/>
	<field name="labtemplate_id" completion="1"/>
	<newline/>
    <field name="startdate"/>
	<field name="enddate"/>
</form>'''

fields = {
    'patient_id': dict(string=u'Patient', type='many2one', relation='hospital.patient'),
	'labtemplate_id': dict(string=u'Lab Test', type='many2one', relation='hospital.lab.template'),
	'startdate' : dict(string=u'Start Date', type='date'),
	'enddate' : dict(string=u'End Date', type='date'),
}

def _get_value(self, cr, uid, data, context):
    if data['model']=='hospital.patient':
		fields['patient_id']['readonly']=1
    return dict(patient_id=data['id'])
def check_labtests(self, cr, uid, data, context):
	lab_template=data['form']['labtemplate_id']
	partner_id=data['form']['patient_id'] if data['form']['patient_id'] else data['id']
	startdate=data['form']['startdate'] 
	enddate=data['form']['enddate'] 
	obj = pooler.get_pool(cr.dbname).get('hospital.lab.test')
	print lab_template
	sarray=[('labtemplate_id', '=', lab_template),('patient_id', '=', partner_id)]
	if startdate: sarray.append(('date_analysis', '>', startdate))
	if enddate: sarray.append(('date_analysis', '<', enddate))
	test_ids = obj.search(cr, uid, sarray)
	if not test_ids:
		raise wizard.except_wizard(_('No Results'),_('No Results.'))
	return dict()
class wizard_report(wizard.interface):
    states={
        'init':{
            'actions':[_get_value],
            'result':{'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel','gtk-cancel'),('report','Print','gtk-print')]}
        },
        'report':{
            'actions':[check_labtests],
            'result':{'type':'print', 'report':'hospital.lab_progress', 'state':'end'}
        }
    }
wizard_report('hospital.lab_progress_wizard')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

